unit kpkp;

interface

uses ZLib, uMisc, kpkpbu;

function EvaluateKPKP(pboard:pbytearray; btm:boolean; eps:integer): integer;


implementation

const
 apawncode: array[0..63] of byte = (
  99,99,99,99,99,99,99,99,
  03,02,01,00,99,99,99,99,
  07,06,05,04,99,99,99,99,
  11,10,09,08,99,99,99,99,
  15,14,13,12,99,99,99,99,
  19,18,17,16,99,99,99,99,
  23,22,21,20,99,99,99,99,
  99,99,99,99,99,99,99,99
 );

tbsize = 64*64*24*48 div 8;

var
 kpdata: array[0..tbsize - 1] of byte;

function getindex(ak,ap,bk,bp:integer): integer;
var apx: integer;
begin
   result := -1;
   apx := ap and 7;
   if apx >= 4 then begin
      bp := (bp and $f8) + (7 - (bp and 7));
      ak := (ak and $f8) + (7 - (ak and 7));
      bk := (bk and $f8) + (7 - (bk and 7));
      ap := (ap and $f8) + (7 - (ap and 7));
   end;
   ap := apawncode[ap];
   dec(bp,8);
   if (ap > 23) or (bp > 47) then exit;
   result := ak + (bk shl 6) + ap*4096 + bp*4096*24;
end;

function kpkp_ending(ak,ap,bk,bp:integer): boolean;
var index,bit: integer;
begin
   result := false;
   index := getindex(ak,ap,bk,bp);
   if index < 0 then exit;
   bit := 1 shl (index and 7);
   index := index shr 3;
   if (kpdata[index] and bit) <> 0 then result := true;
end;

function EvaluateKPKP(pboard:pbytearray; btm:boolean; eps:integer): integer;
var i,ak,bk,ap,bp: integer;
begin
   if eps <> 255 then begin
      if btm then result := -50 else result := 50;
      exit;
   end;
   ak := 999; bk := 999; ap := 999; bp := 999;
   for i := 0 to 63 do
       case pboard[i] of
        APAWN: ap := i;
        AKING: ak := i;
        BPAWN: bp := i;
        BKING: bk := i;
       end;
   //if ak+bk+ap+bp >= 999 then raise exception.create('kpkp ??');
   if btm then begin
      i := ak;
      ak := VFlipSquare8(bk);
      bk := VFlipSquare8(i);
      i := ap;
      ap := VFlipSquare8(bp);
      bp := VFlipSquare8(i);
   end;
   result := 4 + ((ap shr 3) - (7 - (bp shr 3))) * 8;
   if kpkp_ending(ak,ap,bk,bp) then inc(result,350 - distboard(ak,ap+8));
   if btm then result := -result;
end;

initialization

 DecompressToUserBuf(@kpkpbuf,70902,@kpdata,589824);

end.
