unit kqkr;

interface

uses uMisc;

function EvaluateKQKR(pboard:pbytearray; btm:boolean): integer;


implementation

const
 kqkrbonus: array[0..63] of byte = (
 72,62,40,20,20,40,62,72,
 62,50,30,10,10,30,50,62,
 40,30,07,04,04,07,30,40,
 20,10,04,00,00,04,10,20,
 20,10,04,00,00,04,10,20,
 40,30,07,04,04,07,30,40,
 62,50,30,10,10,30,50,62,
 72,62,40,20,20,40,62,72
 );

 rdist: array[0..7] of byte = (0,5,15,25,29,31,32,33);
 kdist: array[0..7] of byte = (30,30,30,15,7,3,1,0);
 qdist: array[0..7] of byte = (30,30,30,25,20,15,7,0);

function EvaluateKQKR(pboard:pbytearray; btm:boolean): integer;
var
  i,ak,bk,aq,br,bonp,bonk,bonr,bonq: integer;
  blackadv: boolean;
begin
   ak := 999; bk := 999; aq := 999; br := 999;
   for i := 0 to 63 do
       case pboard[i] of
        AKING: ak := i;
        BKING: bk := i;
        AQUEEN,BQUEEN: aq := i;
        AROOK,BROOK: br := i;
       end;
   //if ak+bk+ap+bp >= 999 then raise exception.create('kqkr ??');
   blackadv := pboard[aq] = BQUEEN;
   if blackadv <> btm then begin
      result := 0;
      exit;
   end;
   if blackadv then begin
      i := ak;
      ak := bk;
      bk := i;
   end;
   bonp := kqkrbonus[bk];
   bonk := kdist[distboard(bk,ak)];
   bonr := rdist[distboard(bk,br)];
   bonq := qdist[distboard(bk,aq)];
   result := 400 + (bonp+bonk+bonr+bonq) div 4 + (bonp*bonk div 32)
             + (bonp*bonr div 32) + (bonp*bonk*bonr) div 2048;
   if (ak and 7) = (br and 7) then dec(result,2);
   if (ak shr 3) = (br shr 3) then dec(result,2);
   if blackadv then result := -result;
end;

end.
