unit uBoard;

interface

//{$DEFINE DelfiDebug}

uses Windows, uMisc;

type
 TChessBrd = record
  EPSquare,Castle,DrawingMoves,LastCapSquare,LastMove,
  AKingPos,BKingPos,HashB1,HashB2,HashP1,HashP2,
  AMatStage,BMatStage,AMatCnt,BMatCnt,
  AXCross,AYCross,BXCross,BYCross: integer;
  BoardArray: array[0..16*12-1] of byte;
  ALoc,BLoc: array[0..15] of byte;
  Dummy1: integer;
 end;

 PChessBrd = ^TChessBrd;

const
 BOARDOFFSET = 16*2 + 4;
 AKCASTLE = 1;
 AQCASTLE = 2;
 BKCASTLE = 16;
 BQCASTLE = 32;
 LOCLAST = 129;

var
 GDebugString: string;

procedure BoardUpdateData(pcb: PChessBrd);
function BoardCheckData(pcb: PChessBrd): boolean;
function BoardSetFEN(pcb:PChessBrd; s:string; var wmove:boolean): boolean;
procedure BoardVerticalFlipSide(pcb:PChessBrd);
procedure BoardHorizontalFlip(pcb: PChessBrd);
function BoardGetXY(pcb:PChessBrd; pos8,x8,y8:integer): integer;
procedure BoardPlayMove(pcb:PChessBrd; m:integer);
function BoardMoveChecked(pcb:PChessBrd; m:integer): integer;


implementation


uses uGenMove;

function SingleRay(mempos:pointer; step:integer): byte; forward;


const

  TO16: array[0..63] of byte = (
  00, 01, 02, 03, 04, 05, 06, 07,
  16, 17, 18, 19, 20, 21, 22, 23,
  32, 33, 34, 35, 36, 37, 38, 39,
  48, 49, 50, 51, 52, 53, 54, 55,
  64, 65, 66, 67, 68, 69, 70, 71,
  80, 81, 82, 83, 84, 85, 86, 87,
  96, 97, 98, 99, 100,101,102,103,
  112,113,114,115,116,117,118,119
 );

 TO8: array[0..127] of byte = (
  00, 01, 02, 03, 04, 05, 06, 07, 00, 00, 00, 00, 00, 00, 00, 00,
  08, 09, 10, 11, 12, 13, 14, 15, 00, 00, 00, 00, 00, 00, 00, 00,
  16, 17, 18, 19, 20, 21, 22, 23, 00, 00, 00, 00, 00, 00, 00, 00,
  24, 25, 26, 27, 28, 29, 30, 31, 00, 00, 00, 00, 00, 00, 00, 00,
  32, 33, 34, 35, 36, 37, 38, 39, 00, 00, 00, 00, 00, 00, 00, 00,
  40, 41, 42, 43, 44, 45, 46, 47, 00, 00, 00, 00, 00, 00, 00, 00,
  48, 49, 50, 51, 52, 53, 54, 55, 00, 00, 00, 00, 00, 00, 00, 00,
  56, 57, 58, 59, 60, 61, 62, 63, 00, 00, 00, 00, 00, 00, 00, 00
 );

 DIAG16: array[0..239] of byte = (
  00, 04, 00, 00, 00, 00, 00, 00, 01, 00, 00, 00, 00, 00, 00, 08,
  00, 00, 04, 00, 00, 00, 00, 00, 01, 00, 00, 00, 00, 00, 08, 00,
  00, 00, 00, 04, 00, 00, 00, 00, 01, 00, 00, 00, 00, 08, 00, 00,
  00, 00, 00, 00, 04, 00, 00, 00, 01, 00, 00, 00, 08, 00, 00, 00,
  00, 00, 00, 00, 00, 04, 00, 00, 01, 00, 00, 08, 00, 00, 00, 00,
  00, 00, 00, 00, 00, 00, 04, 16, 01, 16, 08, 00, 00, 00, 00, 00,
  00, 00, 00, 00, 00, 00, 16, 04, 01, 08, 16, 00, 00, 00, 00, 00,
  00, 02, 02, 02, 02, 02, 02, 02, 00, 02, 02, 02, 02, 02, 02, 02,
  00, 00, 00, 00, 00, 00, 16, 08, 01, 04, 16, 00, 00, 00, 00, 00,
  00, 00, 00, 00, 00, 00, 08, 16, 01, 16, 04, 00, 00, 00, 00, 00,
  00, 00, 00, 00, 00, 08, 00, 00, 01, 00, 00, 04, 00, 00, 00, 00,
  00, 00, 00, 00, 08, 00, 00, 00, 01, 00, 00, 00, 04, 00, 00, 00,
  00, 00, 00, 08, 00, 00, 00, 00, 01, 00, 00, 00, 00, 04, 00, 00,
  00, 00, 08, 00, 00, 00, 00, 00, 01, 00, 00, 00, 00, 00, 04, 00,
  00, 08, 00, 00, 00, 00, 00, 00, 01, 00, 00, 00, 00, 00, 00, 04
 );

 VMATSTAGE: array[0..7] of integer =
             (0, 0, 0, 1, VKNIGHT, VBISHOP, VROOK, VQUEEN);

 VMATCNT: array[0..7] of integer =
             (0, 0, 1, 1, 1+CNTN, 1+CNTB, 1+CNTR, 1+CNTQ);


procedure ChangeLoc(p:pointer; startpos,endpos:integer); forward;
procedure BoardChangePiece(pcb:PChessBrd; piece,pos16: integer); forward;

procedure BoardPlayMove(pcb:PChessBrd; m:integer);
var
 pboard,paloc,pbloc: PByteArray;
 v,startpos,endpos,startpc,xcode,ycode: integer;
 btm: boolean;
const
 KCASTLEXCROSS = (1 shl (5*4)) - (1 shl (7*4));
 QCASTLEXCROSS = (1 shl (3*4)) - 1;
 ARECAP: array[0..7] of byte = (0,0,0,0,3,3,5,10);
 BRECAP: array[0..7] of byte = (1,1,1,1,3,3,5,10);
begin
  pboard := @(pcb.BoardArray[BOARDOFFSET]);
  paloc := @(pcb.ALoc);
  pbloc := @(pcb.BLoc);
  pcb.EPSquare := 255;
  pcb.LastCapSquare := 255;
  pcb.LastMove := m;
  inc(pcb.DrawingMoves);
  endpos := m and 127;
  startpos := (m shr 7) and 127;
  startpc := pboard[startpos];
  btm := (startpc and B_PIECES) <> 0;
  if (startpc and 7) <> PC_KING then
     if btm
        then ChangeLoc(pbloc,startpos,endpos)
        else ChangeLoc(paloc,startpos,endpos);
  v := pboard[endpos];
  xcode := 1 shl ((endpos and 7) shl 2);
  ycode := 1 shl ((endpos shr 4) shl 2);
  with pcb^ do
  if v <> 0 then begin
     DrawingMoves := 0;
     BoardChangePiece(pcb,v,endpos);
     v := v and 7;
     if ARECAP[v] = BRECAP[startpc and 7] then LastCapSquare := endpos;
     if not btm then begin
        ChangeLoc(pbloc,endpos,128);
        dec(BMatStage,VMATSTAGE[v]);
        dec(BMatCnt,VMATCNT[v]);
        if v >= PC_ROOK then begin
           dec(BXCross,xcode);
           dec(BYCross,ycode);
        end;
     end
     else begin
        ChangeLoc(@ALoc,endpos,128);
        dec(AMatStage,VMATSTAGE[v]);
        dec(AMatCnt,VMATCNT[v]);
        if v >= PC_ROOK then begin
           dec(AXCross,xcode);
           dec(AYCross,ycode);
        end;
     end;
  end;
  v := startpc;
  BoardChangePiece(pcb,v,startpos);
  pboard[startpos] := 0;
  with pcb^ do
  case (v and 15) of
   PC_NULL0: ;
   PC_NULL1: ;
   PC_NULL8: ;
   PC_NULL9: ;
   PC_KNIGHT,PC_BKNIGHT: ;
   PC_BISHOP,PC_BBISHOP: ;
   PC_PAWN:
   begin
     DrawingMoves := 0;
     if endpos-startpos = 32 then begin
        if (pboard[endpos+1] = BPAWN) or (pboard[endpos-1] = BPAWN)
           then EPSquare := endpos - 16;
     end
     else begin
        if (endpos-startpos <> 16) and (pboard[endpos] = 0) then begin
           ChangeLoc(pbloc,endpos-16,128);
           BoardChangePiece(pcb,BPAWN,endpos-16);
           pboard[endpos-16] := 0;
           dec(BMatStage);
           dec(BMatCnt);
        end;
     end;
     if m and MPROMOTION <> 0 then begin
        v := (m shr 16) and 3 + 4;
        inc(AMatStage,VMATSTAGE[v] - 1);
        inc(AMatCnt,VMATCNT[v] - 1);
        if v >= PC_ROOK then begin
           inc(AXCross,xcode);
           inc(AYCross,ycode);
        end;
        inc(v,A_PIECES);
     end;
   end;
   PC_ROOK,PC_QUEEN:
   begin
     dec(AXCross,(1 shl ((startpos and 7) shl 2)) - xcode);
     dec(AYCross,(1 shl ((startpos shr 4) shl 2)) - ycode);
   end;
   PC_KING:
   begin
     AKingPos := endpos;
     Castle := Castle and not (AKCASTLE + AQCASTLE);
     if (startpos = _E1) then begin
        if endpos = _G1 then begin
           DrawingMoves := 0;
           ChangeLoc(paloc,_H1,_F1);
           BoardChangePiece(pcb,AROOK,_H1); pboard[_H1] := 0;
           BoardChangePiece(pcb,AROOK,_F1); pboard[_F1] := AROOK;
           inc(AXCross,KCASTLEXCROSS);
        end;
        if endpos = _C1 then begin
           DrawingMoves := 0;
           ChangeLoc(paloc,_A1,_D1);
           BoardChangePiece(pcb,AROOK,_A1); pboard[_A1] := 0;
           BoardChangePiece(pcb,AROOK,_D1); pboard[_D1] := AROOK;
           inc(AXCross,QCASTLEXCROSS);
        end;
     end;
   end;
   PC_BPAWN:
   begin
     DrawingMoves := 0;
     if endpos-startpos = -32 then begin
        if (pboard[endpos+1] = APAWN) or (pboard[endpos-1] = APAWN)
           then EPSquare := endpos + 16;
     end
     else begin
        if (endpos-startpos <> -16) and (pboard[endpos] = 0) then begin
           ChangeLoc(paloc,endpos+16,128);
           BoardChangePiece(pcb,APAWN,endpos+16);
           pboard[endpos+16] := 0;
           dec(AMatStage);
           dec(AMatCnt);
        end;
     end;
     if (m and MPROMOTION) <> 0 then begin
        v := (m shr 16) and 7 + 4;
        inc(BMatStage,VMATSTAGE[v] - 1);
        inc(BMatCnt,VMATCNT[v] - 1);
        if v >= PC_ROOK then begin
           inc(BXCross,xcode);
           inc(BYCross,ycode);
        end;
        inc(v,B_PIECES);
     end;
   end;
   PC_BROOK,PC_BQUEEN:
   begin
     dec(BXCross,(1 shl ((startpos and 7) shl 2)) - xcode);
     dec(BYCross,(1 shl ((startpos shr 4) shl 2)) - ycode);
   end;
   PC_BKING:
   begin
     BKingPos := endpos;
     Castle := Castle and not (BKCASTLE + BQCASTLE);
     if (startpos = _E8) then begin
        if endpos = _G8 then begin
           DrawingMoves := 0;
           ChangeLoc(pbloc,_H8,_F8);
           BoardChangePiece(pcb,BROOK,_H8); pboard[_H8] := 0;
           BoardChangePiece(pcb,BROOK,_F8); pboard[_F8] := BROOK;
           inc(BXCross,KCASTLEXCROSS);
        end;
        if endpos = _C8 then begin
           DrawingMoves := 0;
           ChangeLoc(pbloc,_A8,_D8);
           BoardChangePiece(pcb,BROOK,_A8); pboard[_A8] := 0;
           BoardChangePiece(pcb,BROOK,_D8); pboard[_D8] := BROOK;
           inc(BXCross,QCASTLEXCROSS);
        end;
     end;
   end;
  end;
  BoardChangePiece(pcb,v,endpos);
  pboard[endpos] := v;
  with pcb^ do
  if Castle <> 0 then begin
     if (startpos = _H1) or (endpos = _H1) then Castle := Castle and not AKCASTLE;
     if (startpos = _A1) or (endpos = _A1) then Castle := Castle and not AQCASTLE;
     if (startpos = _H8) or (endpos = _H8) then Castle := Castle and not BKCASTLE;
     if (startpos = _A8) or (endpos = _A8) then Castle := Castle and not BQCASTLE;
  end;
  {$IFDEF DelfiDebug}
  BoardCheckData(pcb);
  {$ENDIF}
end;

procedure ChangeLoc(p:pointer; startpos,endpos:integer);
asm
  push ebx
@cyc:
  mov bl, byte ptr [eax]
  inc eax
  cmp bl, LOCLAST
  jz @end
  cmp bl, dl
  jnz @cyc
  mov byte ptr [eax-1], cl
@end:
  pop ebx
end;

procedure BoardChangePiece(pcb:PChessBrd; piece,pos16: integer);
var i,h1,h2: integer;
begin
  i := (TO8[pos16] shl 4) + (piece and 15);
  h1 := integer(HRANDOM[i]);
  h2 := integer(HRANDOM[i+2]);
  with pcb^ do begin
    HashB1 := HashB1 xor h1;
    HashB2 := HashB2 xor h2;
    if (piece and PAWNMASK <> 0) then begin
       HashP1 := HashP1 xor h1;
       HashP2 := HashP2 xor h2;
    end;
  end;
end;

function BoardMoveChecked(pcb:PChessBrd; m:integer): integer;
var
 pboard: PByteArray;
 startpos,endpos,de,ds,e,kingpos,codepos: integer;
 kmempos: pointer;
 btm,kingup: boolean;
 pz: byte;
const
 DIR_X = 2;
 DIR_Y = 1;
 DIR_KN = 16;
 DIR_B1 = 4;
 DIR_B2 = 8;
 DIR_DIAG = DIR_B1 + DIR_B2;
 DIR_CROSS = DIR_X + DIR_Y;
 SLIDEVEC: array[0..11] of byte = (0, 16, +1, 0, 17, 0, 0, 0, 15, 0, 0, 0);
label
 SCheck;
begin
  result := 0;
  endpos := m and 127;
  pboard := @(pcb.BoardArray[BOARDOFFSET]);
  pz := pboard[endpos];
  btm := (pz and B_PIECES) <> 0;
  if (m and (MPROMOTION + MENPASSANT + MCASTLE)) <> 0 then begin
     if btm
        then result := byte(AisAttackedX(pcb,pcb.AKingpos,false))
        else result := byte(BisAttackedX(pcb,pcb.BKingpos,false));
     if result <> 0 then result := 31;
     exit;
  end;
  if btm then begin
     kingpos := pcb.AKingPos;
     e := pcb.BMatCnt;
  end
  else begin
     kingpos := pcb.BKingPos;
     e := pcb.AMatCnt;
  end;
  kingup := kingpos > endpos;
  startpos := (m shr 7) and 127;
  ds := DIAG16[startpos - kingpos + 120];
  de := DIAG16[endpos - kingpos + 120];
  if de + ds = 0 then exit;
  if de = ds + (m and MCAPTURE) then exit;
  if (e and $fff000 = 0) and (de = 0) then exit;
  kmempos := pointer(integer(pboard) + kingpos);
  codepos := endpos shl 10 + 256;
  case (integer(pz) and 15) of
    PC_NULL0: ;
    PC_NULL1: ;
    PC_NULL8: ;
    PC_NULL9: ;
    PC_PAWN:
        if (kingpos = endpos+17) or (kingpos = endpos+15) then begin
           result := de + DIR_KN + codepos;
           exit;
        end;
    PC_BPAWN:
        if (kingpos = endpos-17) or (kingpos = endpos-15) then begin
           result := de + DIR_KN + codepos;
           exit;
        end;
    PC_KING:
        if (startpos <= _H1) and (ds <> DIR_X) then exit;
    PC_BKING:
        if (startpos >= _A8) and (ds <> DIR_X) then exit;
    PC_KNIGHT, PC_BKNIGHT:
        if (de and $f0) <> 0 then begin
           result := DIR_KN + codepos;
           exit;
        end;
    PC_BISHOP,PC_BBISHOP:
     begin
        e := de and DIR_DIAG;
        if e = 0 then begin
           if (ds and DIR_CROSS) = 0 then exit;
           goto SCheck;
        end;
        e := SLIDEVEC[e];
        if kingup then e := -e;
        if (pbyte(integer(kmempos) + e))^ = pz then result := de + codepos
           else if SingleRay(kmempos,e) = pz then result := de;
     end;
    PC_ROOK,PC_BROOK:
     begin
        e := de and DIR_CROSS;
        if e = 0 then begin
           if (ds and DIR_DIAG) = 0 then exit;
           goto SCheck;
        end;
        e := SLIDEVEC[e];
        if kingup then e := -e;
        if (pbyte(integer(kmempos) + e))^ = pz then result := de + codepos
           else if SingleRay(kmempos,e) = pz then result := de;
     end;
    PC_QUEEN,PC_BQUEEN:
     begin
        e := de and (DIR_DIAG + DIR_CROSS);
        if e = 0 then exit;
        e := SLIDEVEC[e];
        if kingup then e := -e;
        if (pbyte(integer(kmempos) + e))^ = pz then result := de + codepos
           else if SingleRay(kmempos,e) = pz then result := de;
        exit;
     end;
  end;
SCheck:
  if de = ds then exit;
  ds := ds and 15;
  if (ds = 0) or boolean(result) then exit;

  e := SLIDEVEC[ds];
  if btm then begin
     if pcb.AKingPos > startpos then e := -e;
     pz := SingleRay(kmempos,e);
     if (pz and B_PIECES) = 0 then exit;
  end
  else begin
     if pcb.BKingPos > startpos then e := -e;
     pz := SingleRay(kmempos,e);
     if (pz and A_PIECES) = 0 then exit;
  end;
  pz := pz and 7;
  result := ds;
  if (pz = PC_QUEEN) or
     ((pz = PC_BISHOP) and ((ds and DIR_DIAG) <> 0)) or
     ((pz = PC_ROOK) and ((ds and DIR_CROSS) <> 0))
     then exit;
  result := 0;
end;

function SingleRay(mempos:pointer; step:integer): byte;
asm
  add eax, edx
  xor ecx, ecx
@lop:
  mov cl, byte ptr [eax]
  add eax, edx
  test cl,cl
  jz @lop
  mov al, cl
end;

procedure BoardUpdateData(pcb:PChessBrd);
var
 i,v,z,h1,h2,pos: integer;
 pboard: PByteArray;
begin
  pboard := @(pcb.BoardArray[BOARDOFFSET]);
  i := 0;
  with pcb^ do begin
    HashB1 := i; HashB2 := i; HashP1 := i; HashP2 := i;
    AMatStage := i; BMatStage := i; AMatCnt := i; BMatCnt := i;
    AXCross := i; AYCross := i; BXCross := i; BYCross := i;
  end;
  for i := 0 to 15 do begin
      pcb.ALoc[i] := LOCLAST;
      pcb.BLoc[i] := LOCLAST;
  end;
  z := 0;
  for i := 0 to 63 do begin
      pos := TO16[i];
      v := pboard[pos];
      if (v = AKING) or (v and A_PIECES = 0) then continue;
      pcb.ALoc[z] := pos;
      inc(z);
  end;
  z := 0;
  for i := 63 downto 0 do begin
      pos := TO16[i];
      v := pboard[pos];
      if (v = BKING) or (v and B_PIECES = 0) then continue;
      pcb.BLoc[z] := pos;
      inc(z);
  end;
  with pcb^ do
  for i := 0 to 63 do begin
      pos := TO16[i];
      v := pboard[pos];
      if v = 0 then continue;
      if v = AKING then AKingPos := pos;
      if v = BKING then BKingPos := pos;
      z := 1 shl ((i and 7) shl 2);
      if (v = AROOK) or (v = AQUEEN) then inc(AXCross,z);
      if (v = BROOK) or (v = BQUEEN) then inc(BXCross,z);
      z := 1 shl ((i shr 3) shl 2);
      if (v = AROOK) or (v = AQUEEN) then inc(AYCross,z);
      if (v = BROOK) or (v = BQUEEN) then inc(BYCross,z);
      if (v and B_PIECES) <> 0 then begin
         inc(BMatStage,VMATSTAGE[v and 7]);
         inc(BMatCnt,VMATCNT[v and 7]);
      end
      else begin
         inc(AMatStage,VMATSTAGE[v and 7]);
         inc(AMatCnt,VMATCNT[v and 7]);
      end;
      z := (i shl 4) + (v and 15);
      h1 := integer(HRANDOM[z]);
      h2 := integer(HRANDOM[z+2]);
      HashB1 := HashB1 xor h1;
      HashB2 := HashB2 xor h2;
      if (v = APAWN) or (v = BPAWN) then begin
         HashP1 := HashP1 xor h1;
         HashP2 := HashP2 xor h2;
      end;
  end;
end;

function BoardCheckData(pcb: PChessBrd): boolean;
var
 hb1,hb2,hp1,hp2,am,bm,ca,cb,i,cnt,axc,ayc,bxc,byc,offs,v: integer;
 pboard: PByteArray;
 s: string;
begin
  s := '';
  pboard := @(pcb.BoardArray[BOARDOFFSET]);
  cnt := 0;
  for i := 0 to 15 do begin
      if pcb.ALoc[i] >= 128 then continue;
      if (pboard[pcb.ALoc[i]] and A_PIECES) = 0 then s := s + 'ALoc ';
  end;
  for i := 0 to 15 do begin
      if pcb.BLoc[i] >= 128 then continue;
      if (pboard[pcb.BLoc[i]] and B_PIECES) = 0 then s := s + 'BLoc ';
  end;
  for i := 0 to 127 do begin
      if (i and 8) = 0 then begin
         if pboard[i] = 0 then continue;
         if pboard[i] = NBORDER then s := s + 'Border in board '
            else inc(cnt);
         v := 0;
         for offs := 0 to 15 do begin
             if pcb.ALoc[offs] = i then inc(v);
             if pcb.BLoc[offs] = i then inc(v);
         end;
         if ((pboard[i] and 7) <> PC_KING) and (v <> 1) then s := s + 'ALoc-BLoc ';
      end
      else begin
         if pboard[i] <> NBORDER then s := s + 'Missing border ';
      end;
  end;
  for i := 0 to High(pcb.BoardArray) do begin
      offs := integer(pboard) - integer(@pcb.BoardArray);
      if (i >= offs) and (i < offs+128) then continue;
      if pcb.BoardArray[i] <> NBORDER then s := s + 'Missing border ';
  end;
  if not (pcb.EPSquare in [_A3.._H3,_A6.._H6,255]) then s := s + 'EPSquare ';
  if pcb.EPSquare in [_A3.._H3] then begin
     if (pboard[pcb.EPSquare+16] <> APAWN) and
        (pboard[pcb.EPSquare+15] <> BPAWN) and (pboard[pcb.EPSquare+17] <> BPAWN)
        then s := s + 'White EPSquare ';
  end;
  if pcb.EPSquare in [_A6.._H6] then begin
     if (pboard[pcb.EPSquare-16] <> BPAWN) and
        (pboard[pcb.EPSquare-15] <> APAWN) and (pboard[pcb.EPSquare-17] <> BPAWN)
        then s := s + 'Black EPSquare ';
  end;
  if pcb.Castle and (not (AKCASTLE + AQCASTLE + BKCASTLE + BQCASTLE)) <> 0
     then s := s + 'Invalid Castle code ';
  if ((pcb.Castle and (AKCASTLE + AQCASTLE)) <> 0) and
     (not (pcb.AKingPos in [_D1.._E1])) then s := s + 'White Castle ';
  if ((pcb.Castle and (BKCASTLE + BQCASTLE)) <> 0) and
     (not (pcb.BKingPos in [_D8.._E8])) then s := s + 'Black Castle ';
  if pboard[pcb.AKingPos] <> AKING then s := s + 'AKingPos ';
  if pboard[pcb.BKingPos] <> BKING then s := s + 'BKingPos ';
  with pcb^ do begin
    hb1 := HashB1;    hb2 := HashB2;
    hp1 := HashP1;    hp2 := HashP2;
    am := AMatStage;  bm := BMatStage;
    ca := AMatCnt;    cb := BMatCnt;
    axc := AXCross;   ayc := AYCross;
    bxc := BXCross;   byc := BYCross;
    BoardUpdateData(pcb);
    if hp1 <> HashP1 then s := s + 'HashP1 ';
    if hb1 <> HashB1 then s := s + 'HashB1 ';
    if hp2 <> HashP2 then s := s + 'HashP2 ';
    if hb2 <> HashB2 then s := s + 'HashB2 ';
    if am <> AMatStage then s := s + 'AMatStage ';
    if bm <> BMatStage then s := s + 'BMatStage ';
    if ca <> AMatCnt then s := s + 'AMatCnt ';
    if cb <> BMatCnt then s := s + 'BMatCnt ';
    if (axc <> AXCross) or (ayc <> AYCross) then s := s + 'ACross ';
    if (bxc <> BXCross) or (byc <> BYCross) then s := s + 'BCross ';
    if ((AMatCnt + BMatCnt) and 63) <> cnt then s := s + 'MatCnt ';
  end;
  result := s = '';
  if not result then begin
     GDebugString := GDebugString + s + ' ***** ERROR ***** '#13#10;
     MessageBox(0,pchar(s),'BoardCheckData',MB_OK);
  end;
end;

function BoardSetFEN(pcb:PChessBrd; s:string; var wmove:boolean): boolean;
var
 pboard: PByteArray;
 i,j,len,x: integer;
 side: char;
begin
  result := false;
  pboard := @(pcb.BoardArray[BOARDOFFSET]);
  if length(s) < 12
     then s := 'rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1';
  with pcb^ do begin
     EPSquare := 255;
     Castle := 0;
     DrawingMoves := 0;
     LastMove := 0;
     LastCapSquare := 255;
     for j := 0 to High(BoardArray) do BoardArray[j] := NBORDER;
  end;
  for j := 0 to 63 do pboard[TO16[j]] := 0;
  len := length(s);
  i := 1;
  j := 64-8;
  repeat
    if s[i] = '/' then dec(j,16);
    if (len <= i) or (j < 0) or (j > 63) then exit;
    x := TO16[j];
    case s[i] of
     'P': pboard[x] := APAWN;
     'N': pboard[x] := AKNIGHT;
     'B': pboard[x] := ABISHOP;
     'R': pboard[x] := AROOK;
     'Q': pboard[x] := AQUEEN;
     'K': pboard[x] := AKING;
     'p': pboard[x] := BPAWN;
     'n': pboard[x] := BKNIGHT;
     'b': pboard[x] := BBISHOP;
     'r': pboard[x] := BROOK;
     'q': pboard[x] := BQUEEN;
     'k': pboard[x] := BKING;
     '1'..'8': inc(j,ord(s[i]) - ord('1'));
     ' ': break;
     else dec(j);
    end;
    inc(j);
    inc(i);
  until false;
  if len < i+4 then exit;
  inc(i);
  side := s[i];
  if (side <> 'w') and (side <> 'b') then exit;
  wmove := side = 'w';
  inc(i,2);
  repeat
    case s[i] of
     'K': pcb.Castle := pcb.Castle or AKCASTLE;
     'Q': pcb.Castle := pcb.Castle or AQCASTLE;
     'k': pcb.Castle := pcb.Castle or BKCASTLE;
     'q': pcb.Castle := pcb.Castle or BQCASTLE;
     else break;
    end;
    inc(i);
  until false;
  inc(i);
  if i+1 <= len then
     if (s[i] in ['a'..'h']) and (s[i+1] in ['1'..'8'])
        then pcb.EPSquare := StringToSquare(s[i] + s[i+1]);
  BoardUpdateData(pcb);
  result := true;
end;

procedure BoardVerticalFlipSide(pcb:PChessBrd);
var
 i,j,p1,p2: integer;
 pboard: PByteArray;
begin
  pboard := @(pcb.BoardArray[BOARDOFFSET]);
  if pcb.EPSquare <> 255 then pcb.EPSquare := VFlipSquare8(pcb.EPSquare);
  pcb.Castle := ((pcb.Castle shl 4) and $f0) + ((pcb.Castle shr 4) and $0f);
  for i := 0 to 31 do begin
      j := VFlipSquare8(i);
      p1 := pboard[TO16[i]];
      p2 := pboard[TO16[j]];
      if (p1 = APAWN) or (p1 = BPAWN) then p1 := p1 xor (P_APAWNS + P_BPAWNS);
      if (p2 = APAWN) or (p2 = BPAWN) then p2 := p2 xor (P_APAWNS + P_BPAWNS);
      if p1 <> 0 then p1 := p1 xor AB_PIECES;
      if p2 <> 0 then p2 := p2 xor AB_PIECES;
      pboard[TO16[i]] := p2;
      pboard[TO16[j]] := p1;
  end;
  BoardUpdateData(pcb);
end;

procedure BoardHorizontalFlip(pcb: PChessBrd);
var
 i,j,t: integer;
 pboard: PByteArray;
begin
  pboard := @(pcb.BoardArray[BOARDOFFSET]);
  for i := 0 to 63 do begin
      if (i and 7) > 3 then continue;
      j := HFlipSquare8(i);
      t := pboard[TO16[i]];
      pboard[TO16[i]] := pboard[TO16[j]];
      pboard[TO16[j]] := t;
  end;
  BoardUpdateData(pcb);
end;

function BoardGetXY(pcb:PChessBrd; pos8,x8,y8:integer): integer;
var pboard: PByteArray;
begin
  pboard := @(pcb.BoardArray[BOARDOFFSET]);
  if (pos8 < 0) then pos8 := x8 + y8*8;
  if pos8 > 63 then result := 0
     else result := pboard[TO16[pos8]];
end;

end.
