unit uEndgame;

interface

uses uMisc, uBoard;

type

TEndGame = packed record
 pp: integer;
 p3,p2,p1,p0: byte;
end;

const
 EGCOUNT = 24;
 _VBISHOP = VBISHOP shl 16;
 _VKNIGHT = VKNIGHT shl 16;
 _VROOK = VROOK shl 16;
 _VQUEEN = VQUEEN shl 16;
 VNOPAWNS = $7ff0fff0;
 A_KPK = 1;
 B_KPK = 1 shl 16;
 A_KPPK = 2;
 B_KPPK = 2 shl 16;
 AB_KPKP = 1 + (1 shl 16);
 A_KBPK = (VBISHOP+1);
 B_KBPK = (VBISHOP+1) shl 16;
 A_KBPPK = (VBISHOP+2);
 B_KBPPK = (VBISHOP+2) shl 16;
 A_KBPKP = (VBISHOP+1) + (1 shl 16);
 B_KBPKP = (VBISHOP+1) shl 16 + 1;
 A_KRK = VROOK;
 B_KRK = (VROOK shl 16);
 A_KRKP = VROOK + (1 shl 16);
 B_KRKP = 1 + (VROOK shl 16);
 A_KNKP = VKNIGHT + (1 shl 16);
 B_KNKP = 1 + (VKNIGHT shl 16);
 A_KBKP = VBISHOP + (1 shl 16);
 B_KBKP = 1 + (VBISHOP shl 16);
 A_KRKN = VROOK + (VKNIGHT shl 16);
 B_KRKN = VKNIGHT + (VROOK shl 16);
 A_KRKB = VROOK + (VBISHOP shl 16);
 B_KRKB = VBISHOP + (VROOK shl 16);
 A_KRPKR = (1 + VROOK) + (VROOK shl 16);
 B_KRPKR = VROOK + (1 + VROOK) shl 16;
 A_KRKBP = VROOK + (1 + VBISHOP) shl 16;
 B_KRKBP = (1 + VBISHOP) + (VROOK shl 16);
 A_KQK = VQUEEN;
 B_KQK = (VQUEEN shl 16);
 A_KQKP = VQUEEN + (1 shl 16);
 B_KQKP = 1 + (VQUEEN shl 16);
 A_KQKR = VQUEEN + (VROOK shl 16);
 B_KQKR = VROOK + (VQUEEN shl 16);
 AB_KRKR = VROOK + (VROOK shl 16);
 AB_KBKB = VBISHOP + (VBISHOP shl 16);
 AB_KNKN = VKNIGHT + (VKNIGHT shl 16);
 A_KBKN = VBISHOP + (VKNIGHT shl 16);
 B_KBKN = VKNIGHT + (VBISHOP shl 16);
 A_KNNK = VKNIGHT*2;
 B_KNNK = VKNIGHT*2 shl 16;


EGScores: array[0..EGCOUNT-1] of TEndGame = (
 (pp: VKNIGHT;           p3:06; p2:14; p1:22; p0:30),
 (pp: VBISHOP;           p3:06; p2:15; p1:24; p0:33),
 (pp: VROOK;             p3:04; p2:04; p1:04; p0:00),
 (pp: VKNIGHT*2;         p3:21; p2:34; p1:47; p0:60),
 (pp: VBISHOP*2;         p3:06; p2:06; p1:06; p0:00),
 (pp: VKNIGHT+VBISHOP;   p3:06; p2:06; p1:06; p0:01),

 (pp: VBISHOP+VKNIGHT + _VBISHOP;   p3:07; p2:14; p1:21; p0:28),
 (pp: VBISHOP+VKNIGHT + _VKNIGHT;   p3:06; p2:12; p1:18; p0:24),
 (pp: VBISHOP*2 + _VBISHOP;         p3:07; p2:14; p1:21; p0:28),
 (pp: VKNIGHT*2 + _VKNIGHT;         p3:07; p2:14; p1:21; p0:28),
 (pp: VBISHOP*2 + _VKNIGHT;         p3:04; p2:08; p1:12; p0:16),
 (pp: VKNIGHT*2 + _VBISHOP;         p3:07; p2:14; p1:21; p0:28),

 (pp: VROOK + _VKNIGHT;             p3:03; p2:06; p1:09; p0:12),
 (pp: VROOK + _VBISHOP;             p3:03; p2:06; p1:09; p0:12),
 (pp: VROOK+VKNIGHT + _VROOK;       p3:07; p2:14; p1:21; p0:28),
 (pp: VROOK+VBISHOP + _VROOK;       p3:07; p2:14; p1:21; p0:28),

 (pp: VQUEEN + _VROOK;              p3:04; p2:08; p1:12; p0:01),
 (pp: VQUEEN + _VBISHOP*2;          p3:04; p2:08; p1:12; p0:16),
 (pp: VQUEEN + _VKNIGHT*2;          p3:03; p2:06; p1:09; p0:12),
 (pp: VQUEEN + _VKNIGHT+_VBISHOP;   p3:03; p2:06; p1:09; p0:12),
 (pp: VQUEEN + _VROOK+_VBISHOP;     p3:01; p2:02; p1:03; p0:04),
 (pp: VQUEEN + _VROOK+_VKNIGHT;     p3:01; p2:02; p1:03; p0:04),
 (pp: VQUEEN+VBISHOP + _VQUEEN;     p3:07; p2:14; p1:21; p0:28),
 (pp: VQUEEN+VKNIGHT + _VQUEEN;     p3:07; p2:14; p1:21; p0:28)
);

function IsKnownEG(eg:integer): longbool;
function IsFastEG(amatstage,bmatstage: integer): integer;
function DBEndgameX(pcb:PChessBrd; btm:boolean; var wrongside:boolean): integer;


implementation


uses kpk, kpak, krkp, kqkp, kpkp, kqkr, krkn, krpkr;


Function IsKnownEG(eg: integer): longbool;
asm
  push ebx
  mov ebx, eax
  xor eax, eax

  cmp ebx, A_KPK
  setz dl
  cmp ebx, B_KPK
  setz al

  cmp ebx, AB_KPKP
  setz cl
  or al, dl
  cmp ebx, A_KBPK
  setz dl
  or al, cl
  cmp ebx, B_KBPK
  setz cl
  or al, dl
  cmp ebx, A_KRKP
  setz dl
  or al, cl
  cmp ebx, B_KRKP
  setz cl
  or al, dl
  cmp ebx, A_KQKP
  setz dl
  or al, cl
  cmp ebx, B_KQKP
  setz cl
  or al, dl
  cmp ebx, A_KRKN
  setz dl
  or al, cl
  cmp ebx, B_KRKN
  setz cl
  or al, dl
  cmp ebx, A_KRPKR
  setz dl
  or al, cl
  cmp ebx, B_KRPKR
  setz cl
  or al, dl
  cmp ebx, A_KQKR
  setz dl
  or al, cl
  cmp ebx, B_KQKR
  setz cl
  or al, dl

  pop ebx
  or al, cl
end;

function IsFastEG(amatstage,bmatstage: integer): integer;
var eg: integer;
begin
  result := 0;
  eg := amatstage + (bmatstage shl 16);
  if (eg = A_KPK) or (eg = B_KPK) then result := 5;
  if (eg = A_KPPK) or (eg = B_KPPK) then result := 15;
  if (eg = A_KBPK) or (eg = B_KBPK) then result := 30;
  if (eg = A_KBPPK) or (eg = B_KBPPK) then result := 30;
  if (eg = A_KBPKP) or (eg = B_KBPKP) then result := 30;
  if (eg = A_KRK) or (eg = B_KRK) then result := 30;
  if (eg = A_KRKP) or (eg = B_KRKP) then result := 30;
  if (eg = A_KRKBP) or (eg = B_KRKBP) then result := 30;
  if (eg = A_KRPKR) or (eg = B_KRPKR) then result := 40;
  if (eg = A_KQK) or (eg = B_KQK) then result := 30;
  if (eg = A_KQKP) or (eg = B_KQKP) then result := 30;
  if (eg = AB_KBKB) then result := 5;
  if (eg = AB_KRKR) then result := 10;
  if (eg = AB_KNKN) then result := 5;
  if (eg = A_KBKP) or (eg = B_KBKP) then result := 10;
  if (eg = A_KNKP) or (eg = B_KNKP) then result := 20;
  if (eg = A_KBKN) or (eg = B_KBKN) then result := 5;
  if (eg = A_KNNK) or (eg = B_KNNK) then result := 10;
  if (eg = A_KRKN) or (eg = B_KRKN) then result := 30;
  if (eg = A_KRKB) or (eg = B_KRKB) then result := 30;
  result := result * 1000;
end;

function DBEndgameX(pcb:PChessBrd; btm:boolean; var wrongside:boolean): integer;
var
 ak,bk,ap,ab,ar,aq,v,i,mulscore: integer;
 blackadv,kapk,krkp,kpk,kqkp: boolean;
 pboard: PByteArray;
 board8: array[0..67] of byte;
begin
  result := 0;
  WrongSide := false;
  pboard := @(pcb.BoardArray[BOARDOFFSET]);
  with pcb^ do begin
    v := AMatStage + (BMatStage shl 16);
    blackadv := AMatStage < BMatStage;
  end;
  for i := 0 to 63 do board8[i] := pboard[TO16X[i]];
  if v = AB_KPKP then begin
     i := pcb.EPSquare;
     if i <> 255 then i := TO8X[i];
     result := EvaluateKPKP(@board8,btm,i);
     WrongSide := (abs(result) < 200);
     exit;
  end;
  if (v = A_KQKR) or (v = B_KQKR) then begin
     result := EvaluateKQKR(@board8,btm);
     WrongSide := result = 0;
     exit;
  end;
  if (v = A_KRKN) or (v = B_KRKN) then begin
     if (blackadv <> btm) then WrongSide := true
        else result := EvaluateKRKN(@board8,btm);
     if blackadv then result := -result;
     result := result * (256 - pcb.DrawingMoves) div 256;
     exit;
  end;
  if (v = A_KRPKR) or (v = B_KRPKR) then begin
     if (blackadv <> btm) then WrongSide := true
        else result := EvaluateKRPKR16(pboard,false);
     if result = 0 then WrongSide := true;
     if blackadv then result := -result;
     result := result * (256 - pcb.DrawingMoves) div 256;
     exit;
  end;
  ap := 255; ab := 255; ar := 255; aq := 255;
  ak := TO8X[pcb.AKingPos];
  bk := TO8X[pcb.BKingPos];
  for i := 0 to 63 do begin
      v := board8[i];
      if (v = APAWN) or (v = BPAWN) then ap := i;
      if (v = ABISHOP) or (v = BBISHOP) then ab := i;
      if (v = AROOK) or (v = BROOK) then ar := i;
      if (v = AQUEEN) or (v = BQUEEN) then aq := i;
  end;
  kapk := ab <> 255;
  krkp := ar <> 255;
  kqkp := aq <> 255;
  kpk := (ar = 255) and (ab = 255) and (aq = 255);
  if (blackadv <> btm) and not kpk then begin
     WrongSide := true;
     exit;
  end;
  mulscore := 1;
  if blackadv then begin
     v := ak;
     ak := VFlipSquare8(bk);
     bk := VFlipSquare8(v);
     ap := VFlipSquare8(ap);
     ar := VFlipSquare8(ar);
     ab := VFlipSquare8(ab);
     aq := VFlipSquare8(aq);
     btm := not btm;
     mulscore := -1;
  end;
  if kpk then begin
     result := (VPAWN + (ap shr 3)*20
               - distboard(ak,ap+8)*5 + distboard(bk,ap+8)*5) * mulscore;
     if kpk_ending(ak,ap,bk,btm)
        then inc(result,310*mulscore)
        else result := (result - 85*mulscore) div 4;
     exit;
  end;
  if kapk then begin
     result := (VBISHOP + VPAWN + (ap shr 3)*20
                - distboard(ak,ap+8)*4 + distboard(bk,ap+8)*4) * mulscore;
     if not kpbk_ending(ak,ap,ab,bk) then
        result := (result - 420*mulscore) div 3;
     exit;
  end;
  if krkp then begin
     result := (VROOK - (VPAWN + 110) + (ap shr 3)*20
                - distboard(ak,ap)*4 + distboard(bk,ap)*4) * mulscore;
     if krkp_ending(ak,ar,bk,ap)
        then inc(result,90*mulscore)
        else result := (result - 300*mulscore) div 2;
     exit;
  end;
  if kqkp then begin
     result := (VQUEEN - (VPAWN + 110) + (ap shr 3)*20
                - distboard(ak,ap)*4 + distboard(bk,ap)*4) * mulscore;
     if kqkp_ending(ak,aq,bk,ap)
        then result := (result - 680*mulscore) div 2;
     exit;
  end;
end;

end.
