unit uGenCaps;

interface

uses uBoard, uMisc;

function AGenerateCapX(pcb:PChessBrd; pmovearray:pinteger): integer;
function BGenerateCapX(pcb:PChessBrd; pmovearray:pinteger): integer;


implementation


function GenerateCapKing(mempos,color:integer; pcurrmove:pointer): pointer; forward;
function GenerateCapKnight(mempos,color:integer; pcurrmove:pointer): pointer; forward;
function AGenerateCapPawns(mempos:pbytearray; pcurrmove:pinteger): pointer; forward;
function BGenerateCapPawns(mempos:pbytearray; pcurrmove:pinteger): pointer; forward;
function GenerateBCapRook(mempos:integer; pcurrmove:pointer; skip:boolean):pointer; forward;
function GenerateBCapBishop(mempos:integer; pcurrmove:pointer; skip:boolean):pointer; forward;


function GenerateACapBishop(mempos:integer; pcurrmove:pointer; skip:boolean):pointer;
asm
  push ebx
  xor ebx, ebx
  push edi
  mov edi, edx
  push esi
  mov esi, eax
  push ebp
  mov ebp, [edx];

  lea edx, [esi+17]
  mov eax, ebp
@dne:
  mov bl, byte ptr [edx]
  add edx, 17
  add eax, 17
  test bl, bl
  jz @dne
  test bl, B_PIECES;
  setnz bl
  mov [edi], eax

  lea edx, [esi+15]
  mov eax, ebp
  lea edi, [edi + ebx*4]
@dnw:
  mov bl, byte ptr [edx]
  add edx, 15
  add eax, 15
  test bl, bl
  jz @dnw
  test bl, B_PIECES;
  setnz bl
  mov [edi], eax

  mov eax, ebp
  pop ebp
  test cl, cl
  jnz @cend
  lea edi, [edi + ebx*4]
  mov ecx, eax

  lea edx, [esi-15]
  mov eax, ecx
@dse:
  mov bl, byte ptr [edx]
  sub edx, 15
  sub eax, 15
  test bl, bl
  jz @dse
  test bl, B_PIECES;
  setnz bl
  mov [edi], eax

  lea edx, [esi-17]
  mov eax, ecx
  lea edi, [edi + ebx*4]
@dsw:
  mov bl, byte ptr [edx]
  sub edx, 17
  sub eax, 17
  test bl, bl
  jz @dsw
  test bl, B_PIECES;
  setnz bl
  mov [edi], eax
  xor edx, edx
@cend:
  pop esi
  lea eax, [edi + ebx*4]
  pop edi
  pop ebx
end;

function GenerateACapRook(mempos:integer; pcurrmove:pointer; skip:boolean):pointer;
asm
  push ebx
  xor ebx, ebx
  push edi
  mov edi, edx
  push esi
  mov esi, eax
  push ebp
  mov ebp, ecx
  mov ecx, [edx];

  lea edx, [esi+16]
  mov eax, ecx
@dn:
  mov bl, byte ptr [edx]
  add edx, 16
  add eax, 16
  test bl, bl
  jz @dn
  test bl, B_PIECES;
  setnz bl
  mov [edi], eax
  mov edx, ebp

  pop ebp
  test dl, dl
  jnz @cend

  lea edx, [esi-16]
  mov eax, ecx
  lea edi, [edi + ebx*4]
@ds:
  mov bl, byte ptr [edx]
  sub edx, 16
  sub eax, 16
  test bl, bl
  jz @ds
  test bl, B_PIECES;
  setnz bl
  mov [edi], eax

  lea edx, [esi+1]
  mov eax, ecx
  lea edi, [edi + ebx*4]
@de:
  mov bl, byte ptr [edx]
  inc edx
  inc eax
  test bl, bl
  jz @de
  test bl, B_PIECES;
  setnz bl
  mov [edi], eax

  lea edx, [esi-1]
  mov eax, ecx
  lea edi, [edi + ebx*4]
@dw:
  mov bl, byte ptr [edx]
  dec edx
  dec eax
  test bl, bl
  jz @dw
  test bl, B_PIECES;
  setnz bl
  mov [edi], eax
  xor edx, edx
@cend:
  pop esi
  lea eax, [edi + ebx*4]
  pop edi
  pop ebx
end;

function AGenerateCapX(pcb:PChessBrd; pmovearray:pinteger): integer;
var
 pos,mempos,skippos,n: integer;
 pcurrmove: pinteger;
 pboard: pbytearray;
begin
  pcurrmove := pmovearray;
  pboard := @(pcb.BoardArray[BOARDOFFSET]);
  skippos := _A1;
  if ((pintarray(pboard)[0] or pintarray(pboard)[1] or
       pintarray(pboard)[4] or pintarray(pboard)[5]) and $08080808) = 0
       then skippos := _A3;
  if pcb.EPSquare <> 255 then begin
     pos := pcb.EPSquare;
     if pboard[pos-17] = APAWN then begin
        pcurrmove^ := ((pos-17) shl 7 + pos) or (MCAPTURE + MENPASSANT + MPAWNQUICAP);
        inc(integer(pcurrmove),4);
     end;
     if pboard[pos-15] = APAWN then begin
        pcurrmove^ := ((pos-15) shl 7 + pos) or (MCAPTURE + MENPASSANT + MPAWNQUICAP);
        inc(integer(pcurrmove),4);
     end;
  end;
  n := 0;
  while true do begin
     pos := pcb.ALoc[n];
     inc(n);
     if pos = LOCLAST then break;
     pcurrmove^ := pos*(128+1) + MCAPTURE;
     mempos := integer(pboard) + pos;
     case (pboard[pos] and 7) of
       PC_NULL0: continue;
       PC_NULL1: continue;
       PC_PAWN: pcurrmove := AGenerateCapPawns(pointer(mempos),pcurrmove);
       PC_KNIGHT: pcurrmove := GenerateCapKnight(mempos,B_PIECES,pcurrmove);
       PC_BISHOP: pcurrmove := GenerateACapBishop(mempos,pcurrmove,pos<skippos+16);
       PC_ROOK: pcurrmove := GenerateACapRook(mempos,pcurrmove,pos<skippos);
       PC_QUEEN: begin
          pcurrmove := GenerateACapBishop(mempos,pcurrmove,pos<skippos+16);
          pcurrmove^ := pos*(128+1) + MCAPTURE;
          pcurrmove := GenerateACapRook(mempos,pcurrmove,pos<skippos);
       end;
     end;
  end;
  pos := pcb.AKingPos;
  if pos >= skippos-16 then begin
     pcurrmove^ := pos*(128+1) + MCAPTURE;
     pcurrmove := GenerateCapKing(integer(pboard)+pos,B_PIECES,pcurrmove);
  end;
  result := (integer(pcurrmove) - integer(pmovearray)) shr 2;
end;

function AGenerateCapPawns(mempos:pbytearray; pcurrmove:pinteger): pointer;
asm
  mov ecx, dword ptr [edx]
  push esi
  shr ecx, 4
  mov esi, eax
  push ebx
  and ecx, 7
  mov eax, dword ptr [edx]
  xor ebx, ebx
  add eax, MPAWNQUICAP

  cmp ecx, _R7
  jnz @noprom
  add eax, MPROMOTEDQUEEN
  cmp byte ptr [esi+16], 0
  jnz @noprom
  lea ecx, [eax+16]
  and ecx, NOT MCAPTURE
  mov dword ptr [edx], ecx
  add edx, 4

@noprom:
  mov ecx, eax
  test byte ptr [esi+15], B_PIECES
  setnz bl
  add ecx, 15
  mov dword ptr [edx], ecx
  lea edx, [edx + ebx*4]

  mov ecx, eax
  test byte ptr [esi+17], B_PIECES
  setnz bl
  add ecx, 17
  mov dword ptr [edx], ecx
  lea edx, [edx + ebx*4]

  pop ebx
  mov eax, edx
  pop esi
end;

function GenerateCapKing(mempos,color:integer; pcurrmove:pointer):pointer;
asm
  push esi
  mov esi, eax
  push edi
  mov edi, ecx
  push ebx
  mov eax, [edi]
  xor ebx, ebx

  mov ecx, eax
  test byte ptr [esi+1], dl
  setnz bl
  inc ecx
  mov dword ptr [edi], ecx
  lea edi, [edi + ebx*4]

  mov ecx, eax
  test byte ptr [esi-1], dl
  setnz bl
  dec ecx
  mov dword ptr [edi], ecx
  lea edi, [edi + ebx*4]

  mov ecx, eax
  test byte ptr [esi+16], dl
  setnz bl
  add ecx, 16
  mov dword ptr [edi], ecx
  lea edi, [edi + ebx*4]

  mov ecx, eax
  test byte ptr [esi-16], dl
  setnz bl
  sub ecx, 16
  mov dword ptr [edi], ecx
  lea edi, [edi + ebx*4]

  mov ecx, eax
  test byte ptr [esi+17], dl
  setnz bl
  add ecx, 17
  mov dword ptr [edi], ecx
  lea edi, [edi + ebx*4]

  mov ecx, eax
  test byte ptr [esi-17], dl
  setnz bl
  sub ecx, 17
  mov dword ptr [edi], ecx
  lea edi, [edi + ebx*4]

  mov ecx, eax
  test byte ptr [esi+15], dl
  setnz bl
  add ecx, 15
  mov dword ptr [edi], ecx
  lea edi, [edi + ebx*4]

  mov ecx, eax
  test byte ptr [esi-15], dl
  setnz bl
  sub ecx, 15
  mov dword ptr [edi], ecx
  lea edi, [edi + ebx*4]

  pop ebx
  mov eax, edi
  pop edi
  pop esi
end;

function GenerateCapKnight(mempos,color:integer; pcurrmove:pointer):pointer;
asm
  push esi
  mov esi, eax
  push edi
  mov edi, ecx
  push ebx
  mov eax, [edi]
  xor ebx, ebx

  mov ecx, eax
  test byte ptr [esi+14], dl
  setnz bl
  add ecx, 14
  mov dword ptr [edi], ecx
  lea edi, [edi + ebx*4]

  mov ecx, eax
  test byte ptr [esi-14], dl
  setnz bl
  sub ecx, 14
  mov dword ptr [edi], ecx
  lea edi, [edi + ebx*4]

  mov ecx, eax
  test byte ptr [esi+18], dl
  setnz bl
  add ecx, 18
  mov dword ptr [edi], ecx
  lea edi, [edi + ebx*4]

  mov ecx, eax
  test byte ptr [esi-18], dl
  setnz bl
  sub ecx, 18
  mov dword ptr [edi], ecx
  lea edi, [edi + ebx*4]

  mov ecx, eax
  test byte ptr [esi+31], dl
  setnz bl
  add ecx, 31
  mov dword ptr [edi], ecx
  lea edi, [edi + ebx*4]

  mov ecx, eax
  test byte ptr [esi-31], dl
  setnz bl
  sub ecx, 31
  mov dword ptr [edi], ecx
  lea edi, [edi + ebx*4]

  mov ecx, eax
  test byte ptr [esi+33], dl
  setnz bl
  add ecx, 33
  mov dword ptr [edi], ecx
  lea edi, [edi + ebx*4]

  mov ecx, eax
  test byte ptr [esi-33], dl
  setnz bl
  sub ecx, 33
  mov dword ptr [edi], ecx
  lea edi, [edi + ebx*4]

  pop ebx
  mov eax, edi
  pop edi
  pop esi
end;

function BGenerateCapX(pcb:PChessBrd; pmovearray:pinteger): integer;
var
 pos,mempos,skippos,n: integer;
 pcurrmove: pinteger;
 pboard: pbytearray;
begin
  pcurrmove := pmovearray;
  pboard := @(pcb.BoardArray[BOARDOFFSET]);;
  skippos := _H8+1;
  if ((pintarray(pboard)[24] or pintarray(pboard)[25] or
       pintarray(pboard)[28] or pintarray(pboard)[29]) and $10101010) = 0
       then skippos := _H6;
  if pcb.EPSquare <> 255 then begin
     pos := pcb.EPSquare;
     if pboard[pos+17] = BPAWN then begin
        pcurrmove^ := ((pos+17) shl 7 + pos) or (MCAPTURE + MENPASSANT + MPAWNQUICAP);
        inc(integer(pcurrmove),4);
     end;
     if pboard[pos+15] = BPAWN then begin
        pcurrmove^ := ((pos+15) shl 7 + pos) or (MCAPTURE + MENPASSANT + MPAWNQUICAP);
        inc(integer(pcurrmove),4);
     end;
  end;
  n := 0;
  while true do begin
     pos := pcb.BLoc[n];
     inc(n);
     if pos = LOCLAST then break;
     pcurrmove^ := pos*(128+1) + MCAPTURE;
     mempos := integer(pboard) + pos;
     case (pboard[pos] and 7) of
       PC_NULL0: continue;
       PC_NULL1: continue;
       PC_PAWN: pcurrmove := BGenerateCapPawns(pointer(mempos),pcurrmove);
       PC_KNIGHT: pcurrmove := GenerateCapKnight(mempos,A_PIECES,pcurrmove);
       PC_BISHOP: pcurrmove := GenerateBCapBishop(mempos,pcurrmove,pos>skippos-16);
       PC_ROOK: pcurrmove := GenerateBCapRook(mempos,pcurrmove,pos>skippos);
       PC_QUEEN: begin
          pcurrmove := GenerateBCapBishop(mempos,pcurrmove,pos>skippos-16);
          pcurrmove^ := pos*(128+1) + MCAPTURE;
          pcurrmove := GenerateBCapRook(mempos,pcurrmove,pos>skippos);
       end;
     end;
  end;
  pos := pcb.BKingPos;
  if pos <= skippos+16 then begin
     pcurrmove^ := pos*(128+1) + MCAPTURE;
     pcurrmove := GenerateCapKing(integer(pboard)+pos,A_PIECES,pcurrmove);
  end;
  result := (integer(pcurrmove) - integer(pmovearray)) shr 2;
end;

function BGenerateCapPawns(mempos:pbytearray; pcurrmove:pinteger): pointer;
asm
  mov ecx, dword ptr [edx]
  push esi
  shr ecx, 4
  mov esi, eax
  push ebx
  and ecx, 7
  mov eax, dword ptr [edx]
  xor ebx, ebx
  add eax, MPAWNQUICAP

  cmp ecx, _R2
  jnz @noprom
  add eax, MPROMOTEDQUEEN
  cmp byte ptr [esi-16], 0
  jnz @noprom
  lea ecx, [eax-16]
  and ecx, NOT MCAPTURE
  mov dword ptr [edx], ecx
  add edx, 4

@noprom:
  mov ecx, eax
  test byte ptr [esi-17], A_PIECES
  setnz bl
  sub ecx, 17
  mov dword ptr [edx], ecx
  lea edx, [edx + ebx*4]

  mov ecx, eax
  test byte ptr [esi-15], A_PIECES
  setnz bl
  sub ecx, 15
  mov dword ptr [edx], ecx
  lea edx, [edx + ebx*4]

  pop ebx
  mov eax, edx
  pop esi
end;

function GenerateBCapRook(mempos:integer; pcurrmove:pointer; skip:boolean):pointer;
asm
  push edi
  mov edi, edx
  push ebx
  xor ebx, ebx
  push esi
  mov esi, eax
  push ebp
  mov ebp, ecx
  mov ecx, [edx];

  lea edx, [esi-16]
  mov eax, ecx
@ds:
  mov bl, byte ptr [edx]
  sub edx, 16
  sub eax, 16
  test bl, bl
  jz @ds
  test bl, A_PIECES
  setnz bl
  mov [edi], eax
  mov edx, ebp

  pop ebp
  test dl, dl
  jnz @cend

  lea edx, [esi+16]
  mov eax, ecx
  lea edi, [edi + ebx*4]
@dn:
  mov bl, byte ptr [edx]
  add edx, 16
  add eax, 16
  test bl, bl
  jz @dn
  test bl, A_PIECES;
  setnz bl
  mov [edi], eax

  lea edx, [esi+1]
  mov eax, ecx
  lea edi, [edi + ebx*4]
@de:
  mov bl, byte ptr [edx]
  inc edx
  inc eax
  test bl, bl
  jz @de
  test bl, A_PIECES;
  setnz bl
  mov [edi], eax

  lea edx, [esi-1]
  mov eax, ecx
  lea edi, [edi + ebx*4]
@dw:
  mov bl, byte ptr [edx]
  dec edx
  dec eax
  test bl, bl
  jz @dw
  test bl, A_PIECES;
  setnz bl
  mov [edi], eax
  xor edx, edx
@cend:
  pop esi
  lea eax, [edi + ebx*4]
  pop ebx
  pop edi
end;

function GenerateBCapBishop(mempos:integer; pcurrmove:pointer; skip:boolean):pointer;
asm
  push ebx
  xor ebx, ebx
  push edi
  mov edi, edx
  push esi
  mov esi, eax
  push ebp
  mov ebp, [edx];

  lea edx, [esi-15]
  mov eax, ebp
@dse:
  mov bl, byte ptr [edx]
  sub edx, 15
  sub eax, 15
  test bl, bl
  jz @dse
  test bl, A_PIECES;
  setnz bl
  mov [edi], eax

  lea edx, [esi-17]
  mov eax, ebp
  lea edi, [edi + ebx*4]
@dsw:
  mov bl, byte ptr [edx]
  sub edx, 17
  sub eax, 17
  test bl, bl
  jz @dsw
  test bl, A_PIECES;
  setnz bl
  mov [edi], eax

  mov eax, ebp
  pop ebp
  test cl, cl
  jnz @cend
  lea edi, [edi + ebx*4]
  mov ecx, eax

  lea edx, [esi+17]
  mov eax, ecx
@dne:
  mov bl, byte ptr [edx]
  add edx, 17
  add eax, 17
  test bl, bl
  jz @dne
  test bl, A_PIECES;
  setnz bl
  mov [edi], eax

  lea edx, [esi+15]
  mov eax, ecx
  lea edi, [edi + ebx*4]
@dnw:
  mov bl, byte ptr [edx]
  add edx, 15
  add eax, 15
  test bl, bl
  jz @dnw
  test bl, A_PIECES;
  setnz bl
  mov [edi], eax
  xor edx, edx
@cend:
  pop esi
  lea eax, [edi + ebx*4]
  pop edi
  pop ebx
end;


end.
