unit uSee;

interface

uses SysUtils, uBoard, uMisc;

function EstimateExchangeX(pcb:PChessBrd; move,margin:integer;
                           blacktomove:boolean): integer;

const
 VMATERIAL: array[0..7] of integer =
  (0, 0, VKING, VPAWN, VKNIGHT, VBISHOP, VROOK, VQUEEN);


implementation


type
 PInteger = ^Integer;

const

 KNIGHTVECT: array[0..8] of integer = (+31,+33,-33,-31,+14,+18,-18,-14,0);
 DIST16: array[0..239] of byte = (
  00, 07, 07, 07, 07, 07, 07, 07, 07, 07, 07, 07, 07, 07, 07, 07,
  00, 07, 06, 06, 06, 06, 06, 06, 06, 06, 06, 06, 06, 06, 06, 07,
  00, 07, 06, 05, 05, 05, 05, 05, 05, 05, 05, 05, 05, 05, 06, 07,
  00, 07, 06, 05, 04, 04, 04, 04, 04, 04, 04, 04, 04, 05, 06, 07,
  00, 07, 06, 05, 04, 03, 03, 03, 03, 03, 03, 03, 04, 05, 06, 07,
  00, 07, 06, 05, 04, 03, 02, 02, 02, 02, 02, 03, 04, 05, 06, 07,
  00, 07, 06, 05, 04, 03, 02, 01, 01, 01, 02, 03, 04, 05, 06, 07,
  00, 07, 06, 05, 04, 03, 02, 01, 00, 01, 02, 03, 04, 05, 06, 07,
  00, 07, 06, 05, 04, 03, 02, 01, 01, 01, 02, 03, 04, 05, 06, 07,
  00, 07, 06, 05, 04, 03, 02, 02, 02, 02, 02, 03, 04, 05, 06, 07,
  00, 07, 06, 05, 04, 03, 03, 03, 03, 03, 03, 03, 04, 05, 06, 07,
  00, 07, 06, 05, 04, 04, 04, 04, 04, 04, 04, 04, 04, 05, 06, 07,
  00, 07, 06, 05, 05, 05, 05, 05, 05, 05, 05, 05, 05, 05, 06, 07,
  00, 07, 06, 06, 06, 06, 06, 06, 06, 06, 06, 06, 06, 06, 06, 07,
  00, 07, 07, 07, 07, 07, 07, 07, 07, 07, 07, 07, 07, 07, 07, 07
 );

function MinMax(scorec,scorenc:integer; ppieces:pinteger):integer; forward;
procedure NSort(var arr:array of integer; n:integer); forward;
function FindKnights(mempos:pointer): integer; forward;
function FindCrossPieces(mempos,off:integer; list:pointer): integer; forward;
function FindDiagPieces(mempos:pointer; list:pointer): integer; forward;


function EstimateExchangeX(pcb:PChessBrd; move,margin:integer;
                          blacktomove:boolean): integer;
var
 pboard: PByteArray;
 i,n,pos,startpos,target,source,vtarget,vsource: integer;
 k,aindex,bindex,matcnt,AKingPos,BKingPos: integer;
 alist,blist: array[0..9] of integer;
 plist: array[0..15] of integer;
const
 VBEHINDQUEEN = 4096;
 DOFF = 120;
label RestoreExit;
begin
  pboard := @(pcb.BoardArray[BOARDOFFSET]);
  result := -5000;
  pos := move and 127;
  startpos := (move shr 7) and 127;
  source := pboard[startpos];
  vsource := VMATERIAL[source and 7];
  target := pboard[pos];
  vtarget := VMATERIAL[target and 7];
  if target = 0 then begin
     result := VPAWN div 2;
     exit;
  end;
  if (target = APAWN) and (pos >= _A7) then inc(vtarget,100);
  if (target = BPAWN) and (pos <= _H2) then inc(vtarget,100);
  if (vsource = VPAWN) and (vtarget >= VKNIGHT) then begin
     result := vtarget;
     exit;
  end;
  pboard[pos] := source;
  pboard[startpos] := 0;
  alist[0] := VPAWN;
  alist[1] := VPAWN;                    
  aindex := ((integer(pboard[pos-17]) and P_APAWNS) +
             (integer(pboard[pos-15]) and P_APAWNS)) shr 6;
  if (aindex > 0) and blacktomove then begin
     if (target = APAWN) and (vsource >= VKNIGHT) then begin
        result := 200 - vsource - aindex*50;
        goto RestoreExit;
     end;
     if (vsource >= VQUEEN) and (vtarget <= VROOK) then begin
        result := vtarget - vsource + 50;
        goto RestoreExit;
     end;
     if vtarget - vsource + VPAWN < margin then goto RestoreExit;
  end;
  blist[0] := VPAWN;
  blist[1] := VPAWN;
  bindex := ((integer(pboard[pos+15]) and P_BPAWNS) +
             (integer(pboard[pos+17]) and P_BPAWNS)) shr 5;
  if (bindex > 0) and not blacktomove then begin
     if (target = BPAWN) and (vsource >= VKNIGHT) then begin
        result := 200 - vsource - bindex*50;
        goto RestoreExit;
     end;
     if (vsource >= VQUEEN) and (vtarget <= VROOK) then begin
        result := vtarget - vsource + 50;
        goto RestoreExit;
     end;
     if vtarget - vsource + VPAWN < margin then goto RestoreExit;
  end;
  matcnt := pcb.AMatCnt or pcb.BMatCnt;
  if (matcnt and $0f00) <> 0 then begin
     i := VKNIGHT;
     alist[aindex] := i;
     alist[aindex+1] := i;
     blist[bindex] := i;
     blist[bindex+1] := i;
     i := FindKnights(@(pboard[pos]));
     inc(aindex,i and 15);
     inc(bindex,i shr 4);
  end;
  if (source = AQUEEN) and (bindex > 0) and (vtarget <= VBISHOP) then begin
     result := vtarget - VQUEEN;
     goto RestoreExit;
  end;
  if (source = BQUEEN) and (aindex > 0) and (vtarget <= VBISHOP) then begin
     result := vtarget - VQUEEN;
     goto RestoreExit;
  end;
  AKingPos := pcb.AKingPos;
  BKingPos := pcb.BKingPos;
  if DIST16[pos-AKingPos+DOFF] = 1 then begin
     alist[aindex] := VKING;
     if AKingPos <> startpos then inc(aindex);
  end;
  if DIST16[pos-BKingPos+DOFF] = 1 then begin
     blist[bindex] := VKING;
     if BKingPos <> startpos then inc(bindex);
  end;
  i := integer(@plist);
  if (matcnt and $f0f000) <> 0 then begin
     i := FindDiagPieces(@(pboard[pos]),pointer(i));
  end;
  if (matcnt and $ff0000) <> 0 then begin
     i := FindCrossPieces(integer(pboard)+pos,16,pointer(i));
     i := FindCrossPieces(integer(pboard)+pos,1,pointer(i));
  end;
  pinteger(i)^ := 0;
  i := 0;
  repeat
    n := plist[i];
    inc(i);
    if n = 0 then break;
    k := VMATERIAL[n and 7] + (n and VBEHINDQUEEN);
    if (n and B_PIECES) <> 0 then begin
       blist[bindex] := k;
       inc(bindex);
    end
    else begin
       alist[aindex] := k;
       inc(aindex);
    end;
  until false;
  result := vtarget;
  if aindex = 0 then begin
     if blacktomove then goto RestoreExit;
     if bindex <> 0 then result := vtarget-vsource;
     goto RestoreExit;
  end;
  if bindex = 0 then begin
     if not blacktomove then goto RestoreExit;
     if aindex <> 0 then result := vtarget-vsource;
     goto RestoreExit;
  end;
  alist[aindex] := 0;
  if aindex > 1 then begin
     if aindex > 8 then aindex := 8;
     NSort(alist,aindex);
  end;
  blist[bindex] := 0;
  if bindex > 1 then begin
     if bindex > 8 then bindex := 8;
     NSort(blist,bindex);
  end;
  if blacktomove then
  for i := 0 to 7 do begin
      plist[i*2] := alist[i];
      plist[i*2+1] := blist[i];
  end else
  for i := 0 to 7 do begin
      plist[i*2] := blist[i];
      plist[i*2+1] := alist[i];
  end;
  result := -MinMax(vsource-vtarget,-vtarget,@(plist[0]));
RestoreExit:
  pboard[startpos] := source;
  pboard[pos] := target;
end;

function FindKnights(mempos:pointer): integer;
asm
  push esi
  mov esi, eax
  push edi
  mov edx, 31
  mov edi, offset KNIGHTVECT
  push ebx
  xor eax, eax
  add edi, 4
@cyc:
  cmp byte ptr [esi+edx], BKNIGHT
  setz bl
  cmp byte ptr [esi+edx], AKNIGHT
  setz cl
  mov edx, dword ptr [edi]
  shl bl, 4
  add al, cl
  add edi, 4
  add al, bl
  test edx, edx
  jnz @cyc
  pop ebx
  pop edi
  pop esi
end;

function FindDiagPieces(mempos:pointer; list:pointer): integer;
asm
  push edi
  lea edi, [eax+15]
  push esi
  mov esi, edx
  mov edx, 15
  push ebx
  xor ebx, ebx
  push ebp
  xor ecx, ecx
  mov ebp, (50+17) + (50-15) shl 8 + (50-17) shl 16 + (50+0) shl 24
  push eax

@cyc:
  mov cl, [edi]
  add edi, edx
  test cl, cl
  jz @cyc
  mov eax, ecx
  add eax, ebx
  and cl, 7
  mov [esi], eax
  cmp cl, PC_QUEEN
  setz al
  cmp cl, PC_BISHOP
  jl @endl
  shl eax, 12
  cmp cl, PC_ROOK
  jz @endl
  and eax, 4096
  add esi, 4
  or ebx, eax
  jmp @cyc

@endl:
  mov edx, ebp
  shr ebp, 8
  and edx, $ff
  mov edi, [esp]
  sub edx, 50
  xor ebx, ebx
  add edi, edx
  test edx, edx
  jnz @cyc

  pop edx
  pop ebp
  mov eax, esi
  pop ebx
  pop esi
  pop edi
end;

function FindCrossPieces(mempos,off:integer; list:pointer): integer;
asm
  push edi
  mov edi, eax
  push esi
  mov esi, ecx
  add edi, edx
  push ebx
  xor ecx, ecx
  push ebp
  xor ebx, ebx
  mov ebp, eax

@cyc:
  mov cl, [edi]
  add edi, edx
  test cl, cl
  jz @cyc
  mov eax, ecx
  add eax, ebx
  and cl, 7
  mov [esi], eax
  cmp cl, PC_QUEEN
  setz al
  cmp cl, PC_ROOK
  jl @endl
  shl eax, 12
  add esi, 4
  and eax, 4096
  or ebx, eax
  jmp @cyc

@endl:
  neg edx
  mov edi, ebp
  xor ebx, ebx
  add edi, edx
  cmp edx, 0
  jl @cyc

  pop ebp
  pop ebx
  mov eax, esi
  pop esi
  pop edi
end;

procedure NSort(var arr:array of integer; n:integer);
var i,j,a: integer;
begin
  for j := 2 to n do begin
      a := arr[j-1];
      i := j-1;
      while (i > 0) and (arr[i-1] > a) do begin
         arr[i] := arr[i-1];
         dec(i);
      end;
      arr[i] := a;
  end;
end;

function MinMax(scorec,scorenc:integer; ppieces:pinteger):integer;
var cap: integer;
begin
  cap := ppieces^ and (not 4096);
  if ppieces^ = 0 then begin
     result := scorenc;
     exit;
  end;
  inc(integer(ppieces),4);
  result := -MinMax(cap-scorec,-scorec,ppieces);
  if scorenc > result then result := scorenc;
end;

end.
